package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: TransactionType
// UnionValue: CreateToken

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("CreateToken")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class CreateToken implements TransactionBody {
	public final TransactionType type = TransactionType.CREATE_TOKEN;
	private Url url;
	private String symbol;
	private long precision;
	private Url properties;
	private java.math.BigInteger supplyLimit;
	private Url[] authorities;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public CreateToken url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public CreateToken url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public String getSymbol() {
	    return symbol;
	}
	public void setSymbol(final String value) {
	    this.symbol = value;
	}

	public CreateToken symbol(final String value) {
	    setSymbol(value);
	    return this;
	}
	public long getPrecision() {
	    return precision;
	}
	public void setPrecision(final long value) {
	    this.precision = value;
	}

	public CreateToken precision(final long value) {
	    setPrecision(value);
	    return this;
	}
	public Url getProperties() {
	    return properties;
	}
	public void setProperties(final Url value) {
	    this.properties = value;
	}

	public CreateToken properties(final Url value) {
	    setProperties(value);
	    return this;
	}
	public CreateToken properties(final String value) {
	    setProperties(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getSupplyLimit() {
	    return supplyLimit;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setSupplyLimit(final java.math.BigInteger value) {
	    this.supplyLimit = value;
	}

	public CreateToken supplyLimit(final java.math.BigInteger value) {
	    setSupplyLimit(value);
	    return this;
	}
	public Url[] getAuthorities() {
	    return authorities;
	}
	public void setAuthorities(final Url[] value) {
	    this.authorities = value;
	}

	public CreateToken authorities(final Url[] value) {
	    setAuthorities(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.symbol == null || this.symbol.length() == 0)) {
            marshaller.writeString(4, this.symbol);
        }
        if (!(this.precision == 0)) {
            marshaller.writeUint(5, this.precision);
        }
        if (!(this.properties == null)) {
            marshaller.writeUrl(6, this.properties);
        }
        if (!((this.supplyLimit).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(7, this.supplyLimit);
        }
        if (!(this.authorities == null || this.authorities.length == 0)) {
            marshaller.writeUrl(9, this.authorities);
        }
        return marshaller.array();
    }
}
